package biss.awt;

import biss.awt.kernel.*;
import biss.Queue; 
import biss.awt.Awt;
import biss.awt.GUIHandler;
import biss.awt.GifProducer;
import java.awt.peer.*;

import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.applet.AudioClip;
import java.awt.Image;
import java.net.URL;
import java.util.Enumeration;
import java.util.Vector;
import java.util.*;


/**
 * very crude and preliminary class to test the java.awt.peer role of
 * biss.awt classes. Has to be called like:
 *          java biss.awt.AppletViewer <AppletClass>
 * (i.e. with the class name instead of the html file). It does not
 * provide any parameter mechanism yet.
 * Will be extended towards standard 'appletviewer' compatibility
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class AppletViewer
  extends TopWindow
  implements AppletStub, AppletContext
{
	Applet App;
	Vector Apps = new Vector();
	String AppCls;
	URL Base;
	int Wid;


public AppletViewer ( String aClass, int w) {
	super( "AppletViewer: " + aClass);
	try {
		Wid = w;
		System.out.println( "Dans applerViewer Wid = " + Wid);
		AppCls = aClass;
		Class c = Class.forName( aClass);
		App = (Applet) c.newInstance();
		App.setStub( this);
		Apps.addElement( App);
		add( "Center", App);

		System.out.println( "Dans applerViewer setBrowser " + Wid);
		//Wid = Awt.DefToolkit.getScreenSize().width;
		//Lib.sync();
		//super.setBrowserWindow(Wid);
		biss.awt.kernel.Toolkit.setBrowserWindow(Wid);
		//biss.awt.kernel.NativeLib.setBrowserWindow(Wid);

		System.out.println( "Dans applerViewer b4 openIn Wid = " + Wid);
		openIn( 0, 0, 300, 300);
		System.out.println( "Dans aViewer after openIn Wid = " + Wid);
		init();
	}
	catch( Throwable t) {
		System.out.println( t);
	}
}

public void appletResize ( int width, int height) {
	System.out.println( "appletResize");
}

public Applet getApplet ( String name) {
	return App;
}

public AppletContext getAppletContext () {
	return this;
}

public Enumeration getApplets () {
	return Apps.elements();
}

public AudioClip getAudioClip ( URL url) {
	return null;
}

public URL getCodeBase () {
	return Base;
}

public URL getDocumentBase () {
	return Base;
}

public Image getImage ( URL url) {
	return Awt.DefToolkit.getImage( url );
}

public String getParameter ( String name) {
	// System.out.println( name);
	return null;
}

void init(){
	try {
		String curDir = System.getProperty( "user.dir");
		Base = new URL( "file", "localhost", curDir + "/" );
		App.init();
		App.start();
	}
	catch( Throwable t) {}
}

public boolean isActive () {
	return true;
}

public static void main ( String[] args) {
	int i,j;
	int wid;
	String arg;

	if ( args.length == 0)
		System.out.println( "usage: AppletViewer <AppletClassName>");
	else {
		i = 0;
		wid = 0;
		while ( i < args.length && args[i].startsWith("-") ) {
			System.out.println(args[i]);
			arg = args[i++];
	
			if ( arg.equals("-windowId")){
				arg = args[i];
				wid = Integer.parseInt( arg);
				i++;
				continue;
			}	
		}
		System.out.println(args[i]);
		new AppletViewer( args[i],wid);
	}
}

public void showDocument ( URL url) {
}

public void showDocument ( URL url, String target) {
}

public void showStatus ( String status) {
}
}
